Codeforces Round 949 (Div. 2) (A~C)

2024-06-01 00:44
文章标签 codeforces round div 949

本文主要是介绍Codeforces Round 949 (Div. 2) (A~C),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

1981A - Turtle and Piggy Are Playing a Game 

        

       贪心,每次取x = 2,求最大分数

// Problem: B. Turtle and an Infinite Sequence
// Contest: Codeforces - Codeforces Round 949 (Div. 2)
// URL: https://codeforces.com/contest/1981/problem/B
// Memory Limit: 256 MB
// Time Limit: 1000 ms
// 
// Powered by CP Editor (https://cpeditor.org)#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define pb push_back
#define x first
#define y second 
#define endl '\n'
#define int long long
const LL maxn = 4e05+7;
const LL N = 5e05+10;
const LL mod = 1e09+7;
const int inf = 0x3f3f3f3f;
const LL llinf = 5e18;
typedef pair<int,int>pl;
priority_queue<LL , vector<LL>, greater<LL> >mi;//小根堆
priority_queue<LL> ma;//大根堆
LL gcd(LL a, LL b){return b > 0 ? gcd(b , a % b) : a;
}LL lcm(LL a , LL b){return a / gcd(a , b) * b;
}
int n , m;
vector<int>a(N , 0);
void init(int n){for(int i = 0 ; i <= n ; i ++){a[i] = 0;}
}
void solve() 
{cin >> n >> m;int l = max(0LL , n - m);int r = n + m;int ans = 0;vector<int>tmp1 , tmp2;long long cnt = 0; //统计从高位数起,a,b有多少位不一样while(l != r){cnt++;l >>= 1;r >>= 1;}while(cnt--) r = (r<<1)^1;cout << r << endl;
}            
signed main() 
{ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);cout.precision(10);int t=1;cin>>t;while(t--){solve();}return 0;
}

1981B - Turtle and an Infinite Sequence 

思路:对于数字i而言,m轮之后的结果是[i - m , i + m]所有数的或。因此只需要求区间或就行了。

// Problem: B. Turtle and an Infinite Sequence
// Contest: Codeforces - Codeforces Round 949 (Div. 2)
// URL: https://codeforces.com/contest/1981/problem/B
// Memory Limit: 256 MB
// Time Limit: 1000 ms
// 
// Powered by CP Editor (https://cpeditor.org)#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define pb push_back
#define x first
#define y second 
#define endl '\n'
#define int long long
const LL maxn = 4e05+7;
const LL N = 5e05+10;
const LL mod = 1e09+7;
const int inf = 0x3f3f3f3f;
const LL llinf = 5e18;
typedef pair<int,int>pl;
priority_queue<LL , vector<LL>, greater<LL> >mi;//小根堆
priority_queue<LL> ma;//大根堆
LL gcd(LL a, LL b){return b > 0 ? gcd(b , a % b) : a;
}LL lcm(LL a , LL b){return a / gcd(a , b) * b;
}
int n , m;
vector<int>a(N , 0);
void init(int n){for(int i = 0 ; i <= n ; i ++){a[i] = 0;}
}
void solve() 
{cin >> n >> m;int l = max(0LL , n - m);int r = n + m;int ans = 0;vector<int>tmp1 , tmp2;long long cnt = 0; //统计从高位数起,a,b有多少位不一样while(l != r){cnt++;l >>= 1;r >>= 1;}while(cnt--) r = (r<<1)^1;cout << r << endl;
}            
signed main() 
{ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);cout.precision(10);int t=1;cin>>t;while(t--){solve();}return 0;
}

1981C - Turtle and an Incomplete Sequence 

    思路:考虑将操作统一,即满足b_{i} = b_{i - 1} /2 或者 b[i] = b[i - 1] * 2 或者b[i] = b[i - 1] * 2+1。因此放二进制上考虑就是将前一个数右移一位或者在末尾填上0或者1。

接下来考虑从x变成y至少需要多少个操作,首先求出x,y的二进制最长公共前缀,然后将x通过右移操作变成其最长公共前缀,然后再通过填1或者填0来变成y。最后之间剩余的数通过反复*2/2操作即可。

        

// Problem: C. Turtle and an Incomplete Sequence
// Contest: Codeforces - Codeforces Round 949 (Div. 2)
// URL: https://codeforces.com/contest/1981/problem/C
// Memory Limit: 256 MB
// Time Limit: 3000 ms
// 
// Powered by CP Editor (https://cpeditor.org)#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define pb push_back
#define x first
#define y second 
#define endl '\n'
const LL maxn = 4e05+7;
const LL N = 5e05+10;
const LL mod = 1e09+7;
const int inf = 0x3f3f3f3f;
const LL llinf = 5e18;
typedef pair<int,int>pl;
priority_queue<LL , vector<LL>, greater<LL> >mi;//小根堆
priority_queue<LL> ma;//大根堆
LL gcd(LL a, LL b){return b > 0 ? gcd(b , a % b) : a;
}LL lcm(LL a , LL b){return a / gcd(a , b) * b;
}
int n , m;
vector<int>a(N , 0);
void init(int n){for(int i = 0 ; i <= n ; i ++){a[i] = 0;}
}
void solve() 
{int n;cin >> n;int bit[n + 5][32];for(int i = 1 ; i <= n ; i ++)cin >> a[i];vector<int>pos;int st = 0 , en = 0;for(int i = 1 ; i <= n ; i ++){if(a[i] != -1){if(!st) st = i;pos.pb(i);for(int j = 0 ; j < 32 ; j ++){bit[i][j] = ((a[i] >> j) & 1);}en = i;}}int f = 0;for(int i = st - 1 ; i >= 1 ; i --){if(f == 0){a[i] = a[i + 1] * 2;}else{a[i] = a[i + 1] / 2;}f ^= 1;}f = 0;for(int i = en + 1 ; i <= n ; i ++){if(i == 1){a[i] = 2;continue;}if(f == 0){a[i] = a[i - 1] * 2;}else{a[i] = a[i - 1] / 2;}f ^= 1;}	int len = pos.size();for(int i = 0 ; i < len - 1; i ++){int l = a[pos[i]] , r = a[pos[i + 1]];int tmp = l;int len1 = 0 , len2 = 0;while(tmp){tmp /= 2;len1++;}tmp = r;while(tmp){tmp/=2;len2++;}int tot = 0;for(int j = 0 ; j < min(len1 , len2) ; j ++){if(bit[pos[i]][len1 - j - 1] == bit[pos[i + 1]][len2 - j - 1])tot++;elsebreak;}int need = len1 + len2 - 2 * tot;//cout << l << " " << r << " " << need << endl;if(pos[i + 1] - pos[i]  < need || (pos[i + 1] - pos[i] - need) % 2 != 0){cout << -1 << endl;return;}int need1 = len1 - tot;int need2 = len2 - tot;int po = pos[i] + 1;for(int j = 0 ; j < need1 ; j ++){a[po] = a[po - 1] / 2;po++;}for(int j = 0 ; j < need2 ; j ++){if(bit[pos[i + 1]][len2 - tot - j - 1] == 0){a[po] = a[po - 1] * 2;}else{a[po] = a[po - 1] * 2 + 1;}po++;}int f = 1;for(po ; po < pos[i + 1] ; po++){if(f == 1){a[po] = a[po - 1] * 2;}else{a[po] = a[po - 1] / 2;}f ^= 1;}}for(int i = 1 ; i <= n ; i ++){cout << a[i] << " ";}cout << endl;
}            int main() 
{ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);cout.precision(10);int t=1;cin>>t;while(t--){solve();}return 0;
}

这篇关于Codeforces Round 949 (Div. 2) (A~C)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1019514

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There